/* $Id: demowindow.cc,v 1.3 2001/10/26 11:14:34 murrayc Exp $ */

/* demowindow.cc
 *
 * Copyright (C) 2001 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "gtkmm/main.h"
#include "demowindow.h"
#include "demos.h"

enum {
  TITLE_COLUMN,
  FILENAME_COLUMN,
  FUNC_COLUMN,
  ITALIC_COLUMN,
  NUM_COLUMNS
};

DemoWindow::DemoWindow()
: Gtk::Window(GTK_WINDOW_TOPLEVEL)
{
  m_pTreeIter = 0;

  set_title("gtkmm Code Demos");

  add(m_HBox);

  //Tree:
  //TreeStore::create() isn't finished yet.
  m_TreeStore = Glib::wrap(gtk_tree_store_new (NUM_COLUMNS, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_POINTER, G_TYPE_BOOLEAN));
  m_pTreeView = new Gtk::TreeView( GTK_TREE_MODEL(m_TreeStore->gobj()) );

  m_refTreeSelection = m_pTreeView->get_selection();
  if(m_refTreeSelection)
    m_refTreeSelection->set_mode(GTK_SELECTION_BROWSE);

  m_pTreeView->set_size_request(200, -1);

  m_HBox.pack_start(*m_pTreeView, false, false);

  //Notebook:
  m_HBox.pack_start(m_Notebook);


//  gtk_notebook_append_page (GTK_NOTEBOOK (notebook),
//			    create_text (&info_buffer, FALSE),
//			    gtk_label_new_with_mnemonic ("_Info"));
//
//  gtk_notebook_append_page (GTK_NOTEBOOK (notebook),
//			    create_text (&source_buffer, TRUE),
//			    gtk_label_new_with_mnemonic ("_Source"));
//
//  tag = gtk_text_buffer_create_tag (info_buffer, "title",
//                                    "font", "Sans 18",
//                                    NULL);



  show_all();
}

DemoWindow::~DemoWindow()
{
  if(m_pTreeIter)
  {
    delete m_pTreeIter;
    m_pTreeIter = 0;
  }

  if(m_pTreeView)
  {
    delete m_pTreeView;
    m_pTreeView = 0;
  }
}

bool DemoWindow::on_delete_event(GdkEventAny* event)
{
  Gtk::Main::quit(); //Isn't there a cleaner way?
  return false;
}
