#include <iostream>
#include "gtkmm/main.h"
#include "gtkmm/window.h"
#include "gtkmm/button.h"
#include <gtk/gtk.h>

using std::cout;

using SigC::slot;
using SigC::bind;


class Buttons : public Gtk::Window
{
public:

  Buttons();
  virtual ~Buttons();

  void callback() 
  {
      std::cout << "The Button was clicked." << std::endl;
  }

  bool on_delete_event(GdkEventAny*)
  {
    Gtk::Main::quit();
    return false;
  }

protected:
  Gtk::Button* m_button;
};


Buttons::Buttons() 
{
  m_button = Glib::manage(new Gtk::Button());
 
  m_button->add_pixlabel("info.xpm", "cool button");
   
  set_title("Pixmap'd buttons!");
  set_border_width(10);

  m_button->signal_clicked.connect( slot(this, &Buttons::callback) );
  
  add(*m_button);
  show_all();
}

Buttons::~Buttons()
{
};

int main (int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);

  Buttons buttons;

  kit.run();
  return 0;
}
