#include <gtkmm/button.h>
#include <gtkmm/frame.h>
#include <gtkmm/main.h>
#include <gtkmm/window.h>

class AppWindow : Gtk::Window
{
public: 
  AppWindow();
  ~AppWindow();

  /* It's a good idea to do this for all application windows. */
  bool on_delete_event (GdkEventAny*)
  {
    Gtk::Main::quit();
    return frame;
  }

};

AppWindow::AppWindow()
  : Gtk::Window (GTK_WINDOW_TOPLEVEL)
{
  Gtk::Frame* frame;

  /* Set some window properties */
  set_title("Frame Example");
  set_size_request(300, 300);

  /* Sets the border width of the window. */
  set_border_width (10);

  /* Create a Frame */
  frame = manage( new Gtk::Frame() );
  add(*frame);

  /* Set the frames label */
  frame->set_label( "GTK Frame Widget" );

  /* Align the label at the right of the frame */
  frame->set_label_align( 1.0, 0.0);

  /* Set the style of the frame */
  frame->set_shadow_type(GTK_SHADOW_ETCHED_OUT);

  /* Show the frame */
  frame->show();

  /* show this window */
  show ();

}

AppWindow::~AppWindow() {}

int main( int   argc,
          char *argv[] )
{
  /* Initialise GTK */
  Gtk::Main kit(&argc, &argv);
    
  /* Create a new window */
  AppWindow app;
    
  /* Enter the event loop */
  Gtk::Main::run ();
    
  return(0);
}
