#include <gtkmm/main.h>
#include <gtkmm/window.h>
#include <gtkmm/box.h>
#include <gtkmm/separator.h>
#include <gtkmm/button.h>
#include <gtkmm/radiobutton.h>
// Gtk-- version of the radiobuttons example from the gtk+ tutorial

class RadioButtons : public Gtk::Window
{
public:

  Gtk::VBox m_box1, m_box2, m_box3;
  Gtk::RadioButton m_rb1, m_rb2, m_rb3;
  Gtk::HSeparator m_seperator;
  Gtk::Button m_closeButton;
  
  RadioButtons();
  
  bool on_delete_event(GdkEventAny*)
  {
    Gtk::Main::quit();
    return false;
  }

  void close_application() 
    {
      on_delete_event(0);
    }

};

RadioButtons::RadioButtons() :
  m_box1(false, 0),
  m_box2(false, 10),
  m_box3(false, 10),
  m_rb1("button1"),
  m_rb2("button2"),
  m_rb3("button3"),
  m_closeButton("close")
{
  set_title("radio buttons");
  set_border_width(0);

  m_rb2.set_group(m_rb1.get_group());
  m_rb3.set_group(m_rb1.get_group());
  
  add(m_box1);
  
  m_box2.set_border_width(10);
  m_box1.pack_start(m_box2);
  
  m_box2.pack_start(m_rb1);
  m_box2.pack_start(m_rb2);
  m_rb2.set_active(true);
  
  m_box2.pack_start(m_rb3);
  
  m_box1.pack_start(m_seperator, false, true, 0);
  
  m_box3.set_border_width(10);
  m_box1.pack_start(m_box3, false, true, 0);
  
  m_closeButton.signal_clicked.connect(slot(this, &RadioButtons::close_application));
  
  m_box3.pack_start(m_closeButton);
  m_closeButton.set_flags(GTK_CAN_DEFAULT);
  m_closeButton.grab_default();
  
  show_all();
}

int main (int argc, char *argv[])
{
          
  // all GTK applications must have a gtk_main(). Control ends here
  // and waits for an event to occur (like a key press or mouse event).
  Gtk::Main myapp(&argc, &argv);

  RadioButtons radiobuttons;

  myapp.run();
  return 0;
}
