dnl 
dnl Gtk Proxy Signal Templates
dnl 
dnl  Copyright 1999 Karl Nelson <kenelson@ece.ucdavis.edu>
dnl 
dnl  This library is free software; you can redistribute it and/or
dnl  modify it under the terms of the GNU Library General Public
dnl  License as published by the Free Software Foundation; either
dnl  version 2 of the License, or (at your option) any later version.
dnl 
dnl  This library is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
dnl  Library General Public License for more details.
dnl 
dnl  You should have received a copy of the GNU Library General Public
dnl  License along with this library; if not, write to the Free
dnl  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
dnl 
// -*- c++ -*-
dnl Ignore the next line
/* This is a generated file, do not edit.  Generated from __file__ */
include(template.macros.m4)
#ifndef __header__
#define __header__

#include <glibmm/closure.h>

typedef struct _GObject GObject;

namespace Glib
{

using SigC::Connection;
using SigC::manage;

//using SigC::slot;
//using SigC::convert;
//using SigC::bind;
//using SigC::Slot0;
//using SigC::Slot1;
//using SigC::Slot2;
//using SigC::Slot3;
//using SigC::Slot4;
//using SigC::Slot5;
//using SigC::Slot6;
//using SigC::Callback0;
//using SigC::Callback1;
//using SigC::Callback2;
//using SigC::Callback3;
//using SigC::Callback4;
//using SigC::Callback5;
//using SigC::Callback6;

// Forward declarations
class Object;


dnl
dnl GTK_PROXY_SIGNAL([P1, P2, ...])
dnl
dnl TODO: What are these ,1,s about?
define([GTK_PROXY_SIGNAL],
[/****************************************************************
***** Gtk Proxy Signal NUM($1)
****************************************************************/
LINE(]__line__[)dnl

template <LIST([class R],1,ARG_CLASS($1),[$1],[
          class T_Obj,class T_gObj],1,const char* signal_name,1)>
class [ProxySignal]NUM($1)
{
public:
  //typedef SigC::[Callback]NUM($1)<LIST(R,1,ARG_TYPE($1),[$1])> Callback;
  typedef SigC::[Slot]NUM($1)<LIST(R,1,ARG_TYPE($1),[$1])> SlotType;

protected:
#ifdef SIGC_CXX_PARTIAL_SPEC
  typedef R RType;
#else
  typedef SigC::Trait<R>::type RType;
#endif

  //friend T_Obj; //Allow the class to emit it's own signals.
public:

  static RType gtk_callback(LIST([GObject*],1,ARG_BOTH($1),[$1], [void* data],1))
  {
    //Get the closure that's passed back by GTK+ in the data argument::
    Closure* pClosure = static_cast<Closure*>(data);

    //Get the Slot Data from our Closure and call it:
    SigC::Slot_* pSlotData = (reinterpret_cast<GClosure_Glibmm*>(pClosure->gobj()))->sigc_slot_;
    SlotType slot(pSlotData); //recreate the specific Slot from the generic Slot Data.

    return slot(ARG_NAME($1));  //Uses Slot::operator().
  }

  Connection connect(const SlotType &s, bool after = false)
  {
    //Create a Closure that will do a g_signal_connect for itself:
    Closure* pClosure = new Closure(obj_, signal_name, (GCallback)gtk_callback, s, after); //deleted much later by glibmm_closure_destroy_notifier_handler().
    return pClosure->get_connection();
  }

  Connection connect_after(const SlotType &s)
  {
    return connect(s, true);
  }

//protected:

  //This can be emitted from inside the object's class, because it's a friend class.
  void emit(ARG_BOTH($1))
  {
    g_signal_emit( LIST([(gpointer)obj_->gobj(), g_signal_lookup (signal_name, G_OBJECT_TYPE (obj_->gobj())), 0],1,ARG_NAME($1),[$1]));
  }

protected:
  T_Obj* obj_; //The C++ wrapper instance of which this EmitProxySignal is a member.
};


template <LIST([class R],1,ARG_CLASS($1),[$1],[
          class T_Obj, class T_gObj],1, const char* signal_name,1)>
class [EmitProxySignal]NUM($1)
  : public [ProxySignal]NUM($1) 
    <LIST([R],1,ARG_TYPE($1),[$1],[T_Obj,T_gObj,signal_name],1)>
{
  public:
    typedef [ProxySignal]NUM($1)<LIST(R,1,ARG_TYPE($1),[$1],[T_Obj,T_gObj,signal_name],1)> Self;
};


//Use this for signals that have return values:
template <LIST([class R],1,ARG_CLASS($1),[$1],[
          class T_Obj, class T_gObj],1, const char* signal_name,1)>
class [EmitProxySignal_After]NUM($1)
  : public [EmitProxySignal]NUM($1)
    <LIST([R],1,ARG_TYPE($1),[$1],[T_Obj,T_gObj,signal_name],1)>
{
protected:
  typedef [EmitProxySignal]NUM($1)<LIST([R],1,ARG_TYPE($1),[$1],[T_Obj,T_gObj,signal_name],1)> type_base;

public:
  Connection connect(const SlotType &s)
  {
    return type_base::connect_after(s);
    //Otherwise the return value would be replaced by the default implementation.
  }

  Connection connect_nofify(const SlotType &s)
  {
    return type_base::connect(s);
    //The return value will be ignored.
  }
};


/*

    private:

#ifdef SIGC_CXX_PARTIAL_SPEC
      typedef R RType;
#else
      typedef SigC::Trait<R>::type RType;
#endif

      static RType callback(LIST(void* d,1,ARG_BOTH($1),[$1]))
        {
          Data* data=(Data*)d;
          return data->obj_->emit(ARG_NAME($1));
        }

    public:
      SlotType slot()
        {
          SigC::SlotData* tmp=manage(new SigC::SlotData());
          Data& data=static_cast<Data&>(tmp->data_);
          data.callback=&callback;
          data.obj_=this;
          SigC::ScopeNode* node=tmp->receiver();
          obj_->register_data(node);
          return tmp;
        }

      //TODO: Some signals should be emitted. Some should not.
      RType emit(ARG_BOTH($1))
        {
          return static_cast<RType (*)(LIST(T_gObj*,1,ARG_TYPE($1),[$1]))>
            (emit_func) (LIST(obj_->gobj(),1,ARG_NAME($1),[$1]));
        }

      RType operator()(ARG_BOTH($1))
        {
          return emit(LIST(obj_->gobj(),1,ARG_NAME($1),[$1]));
        }
*/

])dnl

GTK_PROXY_SIGNAL(ARGS(P,0))
GTK_PROXY_SIGNAL(ARGS(P,1))
GTK_PROXY_SIGNAL(ARGS(P,2))
GTK_PROXY_SIGNAL(ARGS(P,3))
GTK_PROXY_SIGNAL(ARGS(P,4))
GTK_PROXY_SIGNAL(ARGS(P,5))



} /* namespace Glib */

#endif // __header__


