#ifndef GLIBMM_UTILITY_H
#define GLIBMM_UTILITY_H

/* utility.h
 *
 * Copyright 2001 Free Software Foundation
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "glibmm/containers.h"

namespace Glib
{

//These are used by gtkmmproc-generated type conversions:

// Removes the const nature of a ptr
template <class T>
inline T* unconst(const T* t)
  { return const_cast<T*>(t); }


//Converts a non-const gchar* return value to an nstring, freeing it too.
nstring convert_return_gcharp_to_nstring(gchar* pch);

/*
template <class T,class T2>
inline bool is_a(T2& t)
  { return dynamic_cast<T*>(t)!=0; }
*/

} // namespace Glib

#endif // GLIBMM_UTILITY_H
