// -*- c++ -*-
#ifndef _GLIBMM_WRAP_H
#define _GLIBMM_WRAP_H

/* $Id: wrap.h,v 1.6 2001/10/16 18:16:59 murrayc Exp $ */

/* base.h
 *
 * Copyright (C) 1998-2001 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


//#include "glibmm/object.h"
#include "glibmm/ustring.h"

typedef struct _GObject GObject;

namespace Glib
{

class Object;
//lass ObjectClass;


// Get a C++ instance that wraps the C instance.
// This always returns the same C++ instance for the same C instance.
// Each wrapper has it's own override of Glib::wrap().
Object* wrap(GObject* o, bool take_copy = false);
//use take_copy = true when wrapping a struct member.
//GObject*s returned from functions don't need this because the function does an extra ref *for* us.

// Generates an automatic wrapper for a gtkclass.
Object* wrap_auto(GObject* o, bool take_copy = false);

typedef Object* (*WrapNewFunction)(GObject*, bool); //wrap_new() functions.

// Register a new type for auto allocation.
void wrap_register(const char*, WrapNewFunction);

// Request a specific wrapper for an object.
template <class CppObjectType>
CppObjectType* wrap_new(typename CppObjectType::BaseObjectType* o)
{
  return (typename CppObjectType::CppClassType::wrap_new(o));
}

// Get the underlying C instance from the C++ instance.
// This is just like calling gobj(), but it does its own check for a null Glib::Object.
GObject* unwrap(Glib::Object* o);


unsigned int string_hash(const char* key);


} /* namespace Glib */


#endif /* _GLIBMM_WRAP_H */
