/* $Id: gtkmm.h,v 1.4 2001/10/14 15:36:13 murrayc Exp $ */
/* gtkmm - a C++ wrapper for the Gtk toolkit
 *
 * Copyright 1999-2001 Free Software Foundation
 * Copyright 1997 Elliot Lee <sopwith@redhat.com>      
 *                Phil Dawes
 *                Tero Pulkkinen
 *                Guillaume Laurent
 *                  
 * Currently maintained by Karl Nelson. <kenelson@sourceforge.net>
 *                                                        
 * REMEMBER: class_init fixed for C objects (make parser for this)
 *           get_data removed for optimization
 *           virtual functions to nonvirtual where virtual not needed(ok)
 *           check if forgot some signals from widgets
 *           check if friends are needed still(ok)
 *           Gtk_Main to thing that has no instances (hmm, ok)
 * 
 * 20 Aug 1997 Additions to the new callback stuffs by Tero Pulkkinen
 * 20 Aug 1997 Added border_width function to Gtk_Container -class.
 * 20 Aug 1997 Fixed Slot1's to SLOTNAME from Phil's code :)
 * 
 * 22 Aug 1997 Added cbdata support
 * 22 Aug 1997 Added Deletion support
 * 10 Oct 1997 Added proper static typing for builtin widgets
 * 17 Nov 1997 Applied patch from Guillaume Laurent about widget flags.
 * 19 Nov 1997 I messed up the source :) Now it requires egcs to compile :)
 *             How are we going to fix that? (tp)
 * 28 Nov 1997 Return types of signals implemented and now works
 * 29 Nov 1997 Deriving from C-language implementation class starts
 *             to look implementable now. Also now it works properly
 *             with gcc2.7.2 again.
 * 13 Dec 1997 Removed alot of virtual words from the library!
 *             It'd be cheating people to let them think they can override
 *             those methods! The C version calls directly the C functions
 *             and cannot be overriden. Thanks to nether a.k.a Lauri Alanko
 *             for pointing this out.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef GTKMM_H
#define GTKMM_H

//extern "C" {
//#include <gtk/gtk.h>
//}

/* Gtkmm version.  */
extern const int gtkmm_major_version;
extern const int gtkmm_minor_version;
extern const int gtkmm_micro_version;

#include <assert.h>

#include <glibmm/wrap.h>
#include <glibmm/containers.h>
#include <glibmm/proxy.h>

#include <gtkmm/object.h>
#include <gtkmm/accelgroup.h>
#include <gtkmm/adjustment.h>
#include <gtkmm/alignment.h>
#include <gtkmm/arrow.h>
#include <gtkmm/aspectframe.h>
#include <gtkmm/base.h>
#include <gtkmm/bin.h>
#include <gtkmm/box.h>
#include <gtkmm/button.h>
#include <gtkmm/buttonbox.h>
#include <gtkmm/checkbutton.h>
#include <gtkmm/checkmenuitem.h>
#include <gtkmm/clist.h>
#include <gtkmm/colorselection.h>
#include <gtkmm/combo.h>
#include <gtkmm/container.h>
#include <gtkmm/curve.h>
#include <gtkmm/dialog.h>
#include <gtkmm/drawingarea.h>
#include <gtkmm/editable.h>
#include <gtkmm/entry.h>
#include <gtkmm/eventbox.h>
#include <gtkmm/fileselection.h>
#include <gtkmm/fixed.h>
#include <gtkmm/frame.h>
//#include <gtkmm/rc.h>
#include <gtkmm/handlebox.h>
#include <gtkmm/image.h>
#include <gtkmm/inputdialog.h>
#include <gtkmm/item.h>
#include <gtkmm/calendar.h>
#include <gtkmm/ctree.h>
#include <gtkmm/invisible.h>
#include <gtkmm/label.h>
#include <gtkmm/list.h>
#include <gtkmm/listitem.h>
#include <gtkmm/main.h>
#include <gtkmm/menu.h>
#include <gtkmm/menubar.h>
#include <gtkmm/menuitem.h>
#include <gtkmm/menushell.h>
#include <gtkmm/misc.h>
#include <gtkmm/notebook.h>
#include <gtkmm/object.h>
#include <gtkmm/optionmenu.h>
#include <gtkmm/paned.h>
#include <gtkmm/pixmap.h>
#include <gtkmm/preview.h>
#include <gtkmm/progressbar.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/radiomenuitem.h>
#include <gtkmm/range.h>
#include <gtkmm/ruler.h>
#include <gtkmm/scale.h>
#include <gtkmm/scrollbar.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/separator.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/statusbar.h>
#include <gtkmm/style.h>
#include <gtkmm/table.h>
#include <gtkmm/text.h>
#include <gtkmm/tipsquery.h>
#include <gtkmm/togglebutton.h>
#include <gtkmm/toolbar.h>
#include <gtkmm/tooltips.h>
#include <gtkmm/tree.h>
#include <gtkmm/treeitem.h>
#include <gtkmm/viewport.h>
#include <gtkmm/widget.h>
#include <gtkmm/window.h>

#endif /* #ifndef GTKMM_H */
