dnl AC_CXX_IN_STD(CLASS, HEADER, SYMBOL)
dnl   tests the C++ for the presence of class in namespace std.
dnl   If class is _not_ in namespace std, SYMBOL is #defined to
dnl   namespace std {using ::CLASS;}, otherwise empty.
dnl
dnl   This should be used in configure.in
dnl     e.g. AC_CXX_IN_STD([string],[string],GTKMM_USING_STD_STRING)
dnl
AC_DEFUN([AC_CXX_IN_STD],
  [
    AC_MSG_CHECKING(if C++ environment has $1 in std.)
    AC_TRY_LINK(
    [
    #include <]ifelse($2,,$1,$2)[>

    using std::$1;

    ],[
      ;
    ],[
      ac_cxx_$1_in_std=yes
      AC_MSG_RESULT([$ac_cxx_$1_in_std])
      AC_DEFINE($3,[])
    ],[
      ac_cxx_$1_in_std=no
      AC_MSG_RESULT([$ac_cxx_$1_in_std])
      AC_DEFINE($3,[namespace std {using ::$1;}])
    ])
  ])
