dnl $Id: class_boxedtype.m4,v 1.4 2001/10/26 11:14:36 murrayc Exp $

dnl
dnl  _CLASS_BOXEDTYPE(FontDescription,PangoFontDescription, pango_font_description_copy, pango_font_description_free)
dnl

define(`_CLASS_BOXEDTYPE',`dnl
_PUSH()
dnl
dnl  Define the args for later macros
define(`__CPPNAME__',`$1')
define(`__CNAME__',`$2')
define(`__BOXEDTYPE_FUNC_NEW',`$3')
define(`__BOXEDTYPE_FUNC_COPY',`$4')
define(`__BOXEDTYPE_FUNC_FREE',`$5')
define(`__BOXEDTYPE_FUNC_EQUAL',`$6')

dnl
dnl ----------------------- Constructors -------------------------
dnl

dnl
dnl Declares and implements the destructor
dnl
define(`_DTOR',`dnl
_PUSH(SECTION_CC)
__CPPNAME__::~__CPPNAME__`'()
{
}
_POP()')


dnl
dnl Declares and implements the default constructor
dnl
dnl It would be nce for _CTOR_DEFAULT to take the name of the _new function as an argument,
dnl but it gets set to the first argument of _CLASS_BOXEDTYPE instead.
define(`_CTOR_DEFAULT',`dnl
__CPPNAME__`'();dnl
_PUSH(SECTION_CC)
__CPPNAME__::__CPPNAME__`'()
{
  gobject_ = __BOXEDTYPE_FUNC_NEW`'();
}

_POP()
')


_POP()
_SECTION(SECTION_CLASS2)
') dnl End of _CLASS_BOXEDTYPE.


dnl
dnl _END_CLASS_BOXEDTYPE()
dnl   denotes the end of a class
dnl
define(`_END_CLASS_BOXEDTYPE',`
_SECTION(SECTION_HEADER1)
//typedef struct _`'__CNAME__ __CNAME__;
//typedef struct _`'__CNAME__`'Class __CNAME__`'Class;
_SECTION(SECTION_HEADER3)



_SECTION(SECTION_SRC_GENERATED)


__NAMESPACE_BEGIN__

/* The implementation: */

__CPPNAME__`'::__CPPNAME__`'(const __CPPNAME__`'& src)
{
  gobject_ = 0;

  if(src.gobject_)
    gobject_ = __BOXEDTYPE_FUNC_COPY`'(src.gobject_);
}

__CPPNAME__::__CPPNAME__`'(__CNAME__ *castitem, bool make_a_copy /* = false */)
{
  if(!make_a_copy)
  {
    //It was given to us by a function which has already made a copy for us to keep.
    gobject_ = castitem;
  }
  else
  {
    //We are probably getting it via direct access to a struct,
    //so we can not just take it - we have to take a copy of it.
    gobject_ = __BOXEDTYPE_FUNC_COPY`'(castitem);
  }
}


__CPPNAME__`'& __CPPNAME__`'::operator=(const __CPPNAME__`'& src)
{
  if(this != &src)
  {
    gobject_ = 0;

    if(src.gobject_)
      gobject_ = __BOXEDTYPE_FUNC_COPY`'(src.gobject_);
  }

  return *this;
}

__CPPNAME__`'::~`'__CPPNAME__`'()
{
  if(gobject_)
  {
    __BOXEDTYPE_FUNC_FREE`'(gobject_); //This could be a free or an unref, we do not need to know.
    gobject_ = 0;
  }
}

ifelse(__BOXEDTYPE_FUNC_EQUAL,NONE,`dnl
',`dnl
bool __CPPNAME__`'::operator==(const __CPPNAME__`'& src)
{
  return __BOXEDTYPE_FUNC_EQUAL`'(gobj(), const_cast<BaseObjectType*>(src.gobj()));
}
')dnl

bool __CPPNAME__`'::is_null() const
{
  return ( gobject_ == 0);
}

__CNAME__* __CPPNAME__`'::gobj()
{
  return gobject_;
}

const __CNAME__* __CPPNAME__`'::gobj() const
{
  return gobject_;
}

__CNAME__* __CPPNAME__`'::gobj_copy() const
{
  return __BOXEDTYPE_FUNC_COPY`'(gobject_);
}

_IMPORT(SECTION_CC)

__NAMESPACE_END__


dnl
dnl
dnl
dnl
_POP()


dnl The actual class, e.g. Pango::FontDescription, declaration:

_IMPORT(SECTION_CLASS1)
public:
  typedef __CPPNAME__          CppObjectType;
  typedef __CNAME__           BaseObjectType;

  explicit __CPPNAME__`'(__CNAME__ *castitem, bool make_a_copy = false); //Use make_a_copy=true when getting it directly from a struct.
  __CPPNAME__`'(const __CPPNAME__`'& src);
  __CPPNAME__`'& operator=(const __CPPNAME__`'& src);
  virtual ~`'__CPPNAME__`'();

ifelse(__BOXEDTYPE_FUNC_EQUAL,NONE,`dnl
',`dnl
  bool operator==(const __CPPNAME__`'& src);
')dnl

  bool is_null() const;

  __CNAME__* gobj();
  const __CNAME__* gobj() const;
  __CNAME__* gobj_copy() const; //The caller is responsible for freeing it. Use when directly setting fields in structs.

protected:
  BaseObjectType* gobject_;

private:
_IMPORT(SECTION_CLASS2)
')


