dnl $Id: convert_gtk.m4,v 1.19 2001/10/26 11:14:36 murrayc Exp $

define(`__CONVERT_CONST_REFPTR_TO_P',`const_cast<$`'2>($`'3->gobj())')

#
# Table of widgets
#

_EQUAL(gboolean,int)
_EQUAL(gint,int)
_EQUAL(gint*,int*)
_EQUAL(gint&,int&)
_EQUAL(guint,unsigned int)
_EQUAL(guint*,unsigned int*)
_EQUAL(guint&,unsigned int&)
_EQUAL(gchar,char)
_EQUAL(gchar*,char*)
_EQUAL(const gchar*,const char*)
_EQUAL(const-gchar*,const char*)
_EQUAL(GdkAtom,Gdk::Atom)
_EQUAL(const-char*,const-gchar*)
_EQUAL(return-char*,return-gchar*)
#
# Basic Types
_CONVERSION(`int',`bool',`($1)$3')
_CONVERSION(`bool',`int',`(($3)?true:false)')
_CONVERSION(`unsigned int',`bool',`($1)$3',`$3')
_CONVERSION(`bool',`unsigned int',`$3')
_CONVERSION(`guint&',`guint*',`&($3)')
_CONVERSION(`gdouble&',`gdouble*',`&($3)')

# Strings:
_CONVERSION(`const Glib::ustring&',`const char*',`$3.c_str()')
_CONVERSION(`const Glib::ustring&',`gchar*',`const_cast<gchar*>($3.c_str())')
_CONVERSION(`const Glib::nstring&',`const gchar*',`$3.c_str()')
_CONVERSION(`gchar*',`Glib::nstring',`$3')
_CONVERSION(`char*',`Glib::ustring',`$3')
_CONVERSION(`const gchar*',`const Glib::nstring&',`Glib::nstring($3)')
_CONVERSION(`const-gchar*',`Glib::ustring',`Glib::ustring($3)')
_CONVERSION(`const-gchar*',`Glib::nstring',`Glib::nstring($3)')
_CONVERSION(`const-char*',`Glib::ustring',`Glib::ustring($3)')
_CONVERSION(`const gchar*',`const Glib::ustring&',`Glib::ustring($3)')

_CONVERSION(`return-gchar*',`Glib::nstring',`Glib::convert_return_gcharp_to_nstring($3)')
_CONVERSION(`return-gchar*',`Glib::ustring',`Glib::convert_return_gcharp_to_nstring($3)')
_CONVERSION(`return-char*',`Glib::ustring',`Glib::convert_return_gcharp_to_nstring($3)')

# _CONVERSION(`string',`static_string',`($3 ? $1() : $1($3) )')

#
# Ptr (gtk+) -> Ptr (gtkmm)
define(`__FP2P',`($`'2)Glib::unwrap($`'3)')
define(`__RP2P',`Glib::wrap($`'3)')
define(`__RP2PD',`Glib::wrap((tran`'slit($`'2,:,))($`'3))')
_CONVERSION(`GtkAdjustment*',`Gtk::Adjustment*',__RP2P)
_CONVERSION(`GtkAdjustment*',`Adjustment*',__RP2P)
_CONVERSION(`GtkWidget*',`Gtk::Widget*',__RP2P)
_CONVERSION(`GtkWidget*',`Widget*',__RP2P)
_CONVERSION(`GtkWindow*',`Gtk::Window*',__RP2P)


# Style:
_CONVERSION(`GtkStyle*',`Glib::RefPtr<Style>',`Glib::wrap($3)')
_CONVERSION(`const Glib::RefPtr<Style>&',`GtkStyle*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`GtkRcStyle*',`Glib::RefPtr<RcStyle>',`Glib::wrap($3)')
_CONVERSION(`const Glib::RefPtr<RcStyle>&',`GtkRcStyle*',__CONVERT_REFPTR_TO_P)

# AccelGroup:
_CONVERSION(`GtkAccelGroup*',`Glib::RefPtr<AccelGroup>',`Glib::wrap($3)')
_CONVERSION(`const Glib::RefPtr<AccelGroup>&',`GtkAccelGroup*',__CONVERT_REFPTR_TO_P)

#
# Ptr (Gtkmm) -> Ptr (gtk+)
_CONVERSION(`Gtk::Adjustment*',`GtkAdjustment*',__FP2P)
_CONVERSION(`Gtk::Widget*',`GtkWidget*',__FP2P)

#
# Ptr (gtk+) -> Ptr (gtkmm) (downcase)
_CONVERSION(`GtkWidget*',`Gtk::Button*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::Box*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::HBox*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::VBox*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::CList*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::ColorSelection*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::CheckButton*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::Entry*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::FontSelection*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::Label*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::List*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::Menu*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::MenuItem*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::OptionMenu*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::RadioButton*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::Scrollbar*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::HScrollbar*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::VScrollbar*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::Table*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::Tree*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::ScrolledWindow*',__RP2PD)
_CONVERSION(`GtkWidget*',`Gtk::Window*',__RP2PD)

# Ref (Gtkmm) -> GtkWidget* Ptr (gtk+)
define(`__FR2PD',`$`'3.Gtk::Widget::gobj()')
_CONVERSION(`Gtk::MenuShell&',`GtkWidget*',__FR2PD)
_CONVERSION(`Gtk::MenuItem&',`GtkWidget*',__FR2PD)
_CONVERSION(`Gtk::Menu&',`GtkWidget*',__FR2PD)
_CONVERSION(`Gtk::TreeItem&',`GtkWidget*',__FR2PD)
_CONVERSION(`Gtk::Widget&',`GtkWidget*',__FR2PD)


# Ref (Gtkmm) -> Ptr (gtk+)
define(`__FR2P',`($`'2)($`'3.gobj())')
_CONVERSION(`Gtk::Adjustment&',`GtkAdjustment*',__FR2P)
_CONVERSION(`Adjustment&',`GtkAdjustment*',__FR2P)
_CONVERSION(`Gtk::Style&',`GtkStyle*',__FR2P)
_CONVERSION(`Gtk::Widget&',`GtkWidget*',__FR2P)
_CONVERSION(`Gtk::Window&',`GtkWindow*',__FR2P)


#Tree:
_CONVERSION(`LineStyle',`GtkCTreeLineStyle',`($1)($3)')
_CONVERSION(`ExpanderStyle',`GtkCTreeExpanderStyle',`($1)($3)')
_CONVERSION(`CompareDragFunc',`GtkCTreeCompareDragFunc',`($1)($3)')

_CONVERSION(`const Gtk::Widget&',`GtkWidget*',__FR2P)

_CONVERSION(`int&',`int*',`&$3',`*$3')
_CONVERSION(`bool&',`gboolean*',`&(gboolean)$3',`(bool)*$3')
dnl
dnl # These are for fixmegtkconst
_CONVERSION(`gdouble*',`const gdouble*',`const_cast<const gdouble*>($3)',`$3')
_CONVERSION(`const gdouble*',`gdouble*',`const_cast<gdouble*>($3)',`$3')
_CONVERSION(`const guchar*',`guchar*',`const_cast<guchar*>($3)',`$3')

_CONVERSION(`gchar*[]',`const SArray&',`const_cast<$1>((const char*[])$3)')

_CONVERSION(`Group',`GSList*',`Group($3)')
_CONVERSION(`GSList*',`Group',`(GSList*)($3)')

_CONVERSION(`Gtk::Item&',`GtkItem*',__FR2P)
_CONVERSION(Gtk::Notebook_Helpers::Page*,GtkNotebookPage*,`($1)((void*)($3))',`($2)((void*)($3))')

_CONVERSION(`GtkSettings*',`Glib::RefPtr<Settings>', Glib::wrap($3))

# gpointer conversions:
# There's doesn't seem to be a way to tell g_signal_new that it's a pointer to a gint, for instance:
#_CONVERSION(`gint*',`gpointer',`($1)$3')
#_CONVERSION(`gpointer',`gint*',`($1)$3')


# Text:
_CONVERSION(`GtkTextTagTable*',`Glib::RefPtr<TextTagTable>',`Glib::wrap($3)')
_CONVERSION(`GtkTextMark*',`Glib::RefPtr<TextMark>',`Glib::wrap($3)')
_CONVERSION(`const Glib::RefPtr<TextMark>&',`GtkTextMark*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`GtkTextTag*',`Glib::RefPtr<TextTag>',`Glib::wrap($3)')
_CONVERSION(`const Glib::RefPtr<TextTag>&',`GtkTextTag*',__CONVERT_REFPTR_TO_P)
_CONVERSION(`GtkTextBuffer*',`Glib::RefPtr<TextBuffer>',`Glib::wrap($3)')
_CONVERSION(`TextIter&',`GtkTextIter*',__FR2P)
_CONVERSION(`const TextIter&',`const GtkTextIter*',__FR2P)
_CONVERSION(`GtkTextAttributes&',`GtkTextAttributes*',`&($3)')
_CONVERSION(`const Glib::RefPtr<TextTagTable>&',`GtkTextTagTable*',__CONVERT_REFPTR_TO_P)

# Tree:
_CONVERSION(`TreeIter&',`GtkTreeIter*',__FR2P)
_CONVERSION(`const TreeIter&',`const GtkTreeIter*',__FR2P)
_CONVERSION(`TreeViewColumn&',`GtkTreeViewColumn*',__FR2P)
_CONVERSION(`GtkTreeViewColumn*',`TreeViewColumn*',`Glib::wrap($3)')
_CONVERSION(`TreePath&',`GtkTreePath*',__FR2P)
_CONVERSION(`const TreePath&',`const GtkTreePath*',__FR2P)
_CONVERSION(`GtkTreeView*',`TreeView*',`Glib::wrap($3)')
_CONVERSION(`GtkTreeSelection*',`Glib::RefPtr<TreeSelection>',`Glib::wrap($3)')

# Removes these,
# when gtk+ has been patched:
# _CONVERSION(`GdkDevice*',`gpointer',`($1)$3')
# _CONVERSION(`gpointer',`GdkDevice*',`($1)$3')
