
#
# --------------------------- Signal Decl----------------------------
#

# Proxy2<void,   int,int>
#        ^       ^   
#        |       |   
#      Rettype   Arguments


#
# _SIGNAL_PROXY(return_type, name, `<args>')
# Creates e.g. EmitProxySignal2<return_type, arg1, arg2> signal_name
# Also creates a static member string to be used as a template argument - string literals can't be used template args.
#
define(`_SIGNAL_PROXY',`dnl
_PUSH(SECTION_H_EMITPROXYSIGNALS)
ifelse($1,void,`dnl
  Glib::EmitProxySignal`'_NUM($3)<$1`'_COMMA_PREFIX(`$3')`,CppObjectType,BaseObjectType,signal_name_'$2`> signal_'$2;', `dnl
  Glib::EmitProxySignal_After`'_NUM($3)<$1`'_COMMA_PREFIX(`$3')`,CppObjectType,BaseObjectType,signal_name_'$2`> signal_'$2; ')
_POP()
_PUSH(SECTION_H_EMITPROXYSIGNALS_NAMES)
  static const char signal_name_`'$2`[];'
_POP()
_PUSH(SECTION_CC_EMITPROXYSIGNALS_NAMES_INIT)
  const char __CPPNAME__::signal_name_`'$2`[] = "'$2`";'
_POP()
')


dnl
dnl _SIGNAL_PH(gtkname, crettype, cargs and names)
dnl Create a callback and set it in our derived G*Class.
dnl
define(`_SIGNAL_PH',`dnl
_PUSH(SECTION_PCC_CLASS_INIT_DEFAULT_SIGNAL_HANDLERS)
    klass->$1 = `&'$1_callback;
_SECTION(SECTION_PH_DEFAULT_SIGNAL_HANDLERS)
  static $2 $1_callback($3);
_POP()')



#                        $1      $2       $3        $4
# _SIGNAL_PCC(cppname,gtkname,cpprettype,crettype,
#                        $5                $6          $7            $8
#                  `<cargs and names>',`<cnames>',`<cpparg names>',firstarg)
#   
define(`_SIGNAL_PCC',`dnl
_PUSH(SECTION_PCC_DEFAULT_SIGNAL_HANDLERS)
$4 __CPPNAME__`'_Class::$2_callback($5)
  {
    CppObjectType *obj=
dnl Do not change the line below, both casts are necessary
      static_cast<CppObjectType*>(static_cast<Gtk::Object*>(
        gtk_object_get_data_by_id((GtkObject*)$8, Glib::quark_)));

_IMPORT(SECTION_CHECK)
ifelse($4,void,`dnl
    if (obj)
      obj->on_$1($7);
    else
      {
        BaseClassType* base = static_cast<BaseClassType*>( g_type_class_peek_parent(G_OBJECT_GET_CLASS($8)) );

        if (base->$2)
          (base->$2)($6);
      }
',`dnl
    if (obj)
      return _CONVERT($4,$3,`obj->on_$1`'($7)');
    BaseClassType* base=
      static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS($8)));
    if (base->$2)
      return (base->$2)($6);

    return 0;
')
  }

_POP()')


#                    $1      $2       $3 
# _SIGNAL_H(signame,rettype,`<cppargs>')
#
define(`_SIGNAL_H',`dnl
_PUSH(SECTION_H_VFUNCS)
  virtual $2 on_$1($3);
_POP()')

#                    $1      $2       $3     $4       $5          $6
# _SIGNAL_CC(signame,gtkname,rettype,crettype,`<cppargs>',`<carg_names>')
#
define(`_SIGNAL_CC',`dnl
_PUSH(SECTION_CC_DEFAULT_SIGNAL_HANDLERS)
$3 __NAMESPACE__::__CPPNAME__::on_$1($5)
  {
    BaseClassType* base=
      static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)));
    if (base->$2)
ifelse($3,void,`dnl
      (base->$2)(gobj()`'ifelse(`$6',,,`,')$6);
',`dnl
      return _CONVERT($3,$4,(base->$2)(gobj()`'ifelse(`$6',,,`,')$6));
    return 0;
')
  }

_POP()')

